<?php
//----------------------------------------------
// NICOLE Board  [ Freeware ]
// Ǽĥץ [ ե꡼ ]
//
// Script written by NICOLE
// web-page : http://www10.big.or.jp/~nicole/
// e-mail   : nicole@big.or.jp
//
// Revision 2.01P
// Modified by ҤȤ
// web-page : http://revision.s22.xrea.com/
// e-mail   : revision@s22.xrea.com
//----------------------------------------------
session_start();
require_once("./conf.php");
require_once("./lib/pipedb.php");
require_once("./language/lang.php");
require_once("./lib/headfoot.php");
require_once("./lib/common.php");
require_once("./lib/dbaccess.php");
require_once("./lib/view.php");

$html		= new clsHeadFoot();
$com		= new clsCommon();
$view		= new clsView();
$pdb		= new clsPipeDB();
$db			= $pdb->DB_Connect();
$MenuData	= "";
$board		= "";
$page		= 0;

$TopicData	= array();
$ReplyData	= array();
$COOKIE		= array();
$uidlist	= array();

if ( isset($_REQUEST['page']) ) { $page = $_REQUEST['page']; }
if ( isset($_REQUEST['board']) ) { $board = $_REQUEST['board']; }

// INCMˤꥯȤɤå
if( preg_match("/point=([^\&]*)/", $_SERVER["QUERY_STRING"], $buff) ) {
	$incm = new clsINCM();
	$incm->INCM_Output($buff[1], $board, $db, $pdb);
	$db->DisConnect();
	exit;
}

// ̽
$com->ComInit($db, $pdb, $board);

$cmd		= "";
$wparam		= "";
$lparam		= "";
$finselect	= DEF_FIN_SHOW;
$kindselect	= "";
if ( isset($_REQUEST['cmd']) )			{ $cmd = $_REQUEST['cmd']; }
if ( isset($_REQUEST['wparam']) )		{ $wparam = $_REQUEST['wparam']; }
if ( isset($_REQUEST['lparam']) )		{ $lparam = $_REQUEST['lparam']; }
if ( isset($_REQUEST['finselect']) )	{ $COOKIE['finselect'] = $_REQUEST['finselect']; }
if ( isset($_REQUEST['kindselect']) )	{ $COOKIE['kindselect'] = $_REQUEST['kindselect']; }

$dba		= new clsDBAccess();
// Command
if ( $cmd == "topic") {
	$out_buff = $html->DrawHeadder("", 0, 0, 0, $board, $db, $pdb);
	print $out_buff;
	require_once("./lib/drawtopic.php");
	$topic = new clsDrawTopic();
	$out_buff = $topic->Draw($db, $pdb, $board, 1, $wparam, "");
	print $out_buff;
} else if ( $cmd == "disp0") { $COOKIE['disp'] = 0; $view->ViewDisp($db, $pdb, $COOKIE['disp'], $board, $page);
} else if ( $cmd == "disp1") { $COOKIE['disp'] = 1; $view->ViewDisp($db, $pdb, $COOKIE['disp'], $board, $page);
} else if ( $cmd == "sort0") { $COOKIE['sort'] = 0; $view->ViewDisp($db, $pdb, $COOKIE['disp'], $board, $page);
} else if ( $cmd == "sort1") { $COOKIE['sort'] = 1; $view->ViewDisp($db, $pdb, $COOKIE['disp'], $board, $page);
} else if ( $cmd == "last")  {
	$INFO_COOKIE['reply'] = $lparam;
	$com->SetCookieData($board,"on");
	$out_buff = $html->DrawHeadder("", 0, 0, 0, $board, $db, $pdb);
	print $out_buff;
	require_once("./lib/drawtopic.php");
	$topic = new clsDrawTopic();
	$out_buff = $topic->Draw($db, $pdb, $board, 1, $wparam, "");
	print $out_buff;
} else if ( $cmd == "search" && $wparam != "" ) {
	$dba->Search($db, $pdb, $board, $wparam);
} else {
	$view->ViewDisp($db, $pdb, $COOKIE['disp'], $board, $page);
}
$db->DisConnect();
$html->DrawFooter($board);
exit;

class clsINCM {
	function INCM_Output($point=0, $board, $db, $pdb) {
		global $CONFIG;
		global $TopicData, $ReplyData;

		$com		= new clsCommon();
		$dba		= new clsDBAccess();
		$all_read	= 0;

		$com->GetCFG($board);
		$title = $CONFIG['bbstitle'];
		$title = mb_convert_encoding($title, "SJIS", "EUC-JP");

		// ѥ᡼å(ѥ᡼դ̵ϡɤ߹ե饰)
		if ( !preg_match("/^\d\d\d\d\/\d\d\/\d\d,\d\d:\d\d:\d\d$/", $point ) ) { $all_read = 1; }

		// إå
		print "Content-type: text/plain; charset=Shift-JIS\n\n";
		print "#T:{$title}\n";
		print "#RP:DATE\n";
		print "#F:POST,\$C,mode=msg&resno=\$Sr&name=\$N&email=\$E&sub=\$T&comment=\$M&url=\$H&pwd=\$K&color=800000\n";

		// 
		for( $LoopCnt = 1; $LoopCnt <= 2; $LoopCnt++ ) {
			$datIndex = array();

			if ( $LoopCnt == 1 ) {
				// Ƶ
				$SQL_query = "SELECT i_MainID FROM ".DEF_PRE_TABLE.$board."_topic WHERE i_Flag != 2";
			} else {
				// ֿ
				$SQL_query = "SELECT i_SubID FROM ".DEF_PRE_TABLE.$board."_reply";
			}
			$db->Query($SQL_query, $result);
			while ($row = $pdb->DB_fetch_row($result)) {
				$datIndex[] = $row[0];	// IndexֹΤ߼
			}

			// ġεФϤԤ
			foreach( $datIndex as $num ) {
				$dba->GetSingleData($db, $pdb, $board, $LoopCnt, $num);
				if ( $LoopCnt == 1 ) {
					$ComData = $TopicData;
					$atime = $this->FormatDateTime($ComData['i_topicdate']);
				} else {
					$ComData = $ReplyData;
					$atime = $this->FormatDateTime($ComData['i_replydate']);
				}
				$aname = mb_convert_encoding($ComData['name'], "SJIS", "EUC-JP");
				if ( $all_read == 1 || strcoll($atime, $point) >= 0 ) {
					if ( DEF_ADMIN_NAME == $ComData['name'] ) {
						$aname = $aname." [admin]";
					} else if ( $ComData['i_rank'] == 2 ) {
						$aname = $aname." [admin group]";
					} else {
						if ( $ComData['i_rank'] == 1 ) {
							if ( $ComData['tagname'] != "" ) {
								$atag = ""; 
								$atag = mb_convert_encoding($ComData['tagname'], "SJIS", "EUC-JP");
								$aname = $aname." [".$atag."]";
							} else { $aname = $aname." [FixHN]"; }
						}
					}

					if ( $LoopCnt != 1 ) {
						$index_num = $ComData['i_subid']+1000;
						$reply_num = $ComData['i_mainid'];
						$asubject = "ؤΥ [ No.".$ComData['i_mainid']." ]";
						$asubject = mb_convert_encoding($asubject, "SJIS", "EUC-JP");

						$time1 = date("y/m/d", $ComData['i_replydate']);
						$time2 = date("H:i:s", $ComData['i_replydate']);

					} else {
						$index_num = $ComData['i_mainid'];
						$reply_num = 0;
						$asubject = mb_convert_encoding($ComData['subject'], "SJIS", "EUC-JP");
						if ( $CONFIG['menu_use'] != 0 ) {
							$amenu = mb_convert_encoding($ComData['menu'], "SJIS", "EUC-JP");
							if ( 1 == $ComData['i_flag'] ) {
								$asubject="<λ> [ ".$amenu." ] ".$asubject;
							} else if ( 3 == $ComData['i_flag'] ) {
								$asubject="[ ".$amenu." ] = ޤ =";
							} else if ( 0 == $ComData['i_flag'] ) {
								$asubject="[ ".$amenu." ] ".$asubject;
							}
						}

						$time1 = date("y/m/d", $ComData['i_topicdate']);
						$time2 = date("H:i:s", $ComData['i_topicdate']);
					}

					$asubject = html_entity_decode($asubject);
					
					if ( $ComData['email'] != "" ) { $aemail = $ComData['email']; } else { $aemail = ""; }
					if ( $ComData['url'] != "" ) { $ahp = $ComData['url']; } else { $ahp = ""; }

					if ( $ComData['i_flag'] == 3 ) {
						$acomment = "***** бƤޤ *****";
					} else {
						$acomment = mb_convert_encoding($ComData['comment'], "SJIS", "EUC-JP");
					}

					if ( $ComData['icq'] != "" ) { $acomment = "ICQ : ".$ComData['icq']."\n".$acomment; }

					$acomment = preg_replace("/<BR>/i", "\n", $acomment);
					$acomment = html_entity_decode($acomment);
					$acomment = preg_replace("/\n\n\n\n+/", "\n\n\n", $acomment);
					$acomment = preg_replace("/^\n+/", "", $acomment);
					$acomment = preg_replace("/\n+$/", "", $acomment);
					$acomment = preg_replace("/\n\.\n/", "\n \.\n", $acomment);
					$acomment = preg_replace("/^\.\n/", " \.\n", $acomment);

					print "S:{$index_num},{$reply_num},{$time1},{$time2},\n";
					print "T:{$asubject}\n";
					print "N:{$aname}\n";
					if ( $ahp != "" ) { print "H:{$ahp}\n"; }
					if ( $aemail != "" ) { print "E:{$aemail}\n"; }
					print "M:\n$acomment\n";
					print ".\n";
				}
			}
		}	
	}

	function FormatDateTime($atime) {
		$DateStr = date("Y/m/d", $atime);
		$DateStr .= ",".date("H:i:s", $atime);
		return $DateStr;
	}

}

?>
