<?php
class clsDBAccess {
	//========================================================================
	// Function Name	:	GetJoinData
	//------------------------------------------------------------------------
	// Function			:	ǡ(ƵܴϢֿ)
	// Input			:	$db			...	Database Object
	//						$board		... ΤǼ̾
	//						$num		... Ƶֹ
	// Output			:	Globalѿ[TopicData]˿Ƶ
	//						[ReplyData]ֿǼƤ
	//========================================================================
	function GetJoinData($db, $pdb, $board, $num) {
		global $TopicData, $ReplyData;

		$ReplyData = array();

		$SQL_query = "SELECT * from ".DEF_PRE_TABLE.$board."_topic WHERE i_MainID = ".$num;
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);

		$TopicData = $row;
		$SQL_query = "SELECT * from ".DEF_PRE_TABLE.$board."_reply WHERE i_MainID = $num ORDER BY i_ReplyDate";
		$db->Query($SQL_query, $result);
		while ($row = $pdb->DB_fetch_assoc($result)) {
			$ReplyData[] = $row['i_subid']."<>".$row['i_mainid']."<>".$row['i_replydate']."<>".$row['name']."<>".$row['tagname']."<>".$row['i_rank']."<>".$row['email']."<>".$row['url']."<>".$row['icq']."<>".$row['ip']."<>".$row['pwd']."<>".$row['comment']."<>".$row['remote_host']."<>".$row['i_flag']."<>".$row['i_uid']."<>".$row['tripid']."<>".$row['i_update']."<>".$row['upname'];
		}
	}

	//========================================================================
	// Function Name	:	GetSingleData
	//------------------------------------------------------------------------
	// Function			:	ǡ(Ƶ or ֿ)
	// Input			:	$db			...	Database Object
	//						$board		... ΤǼ̾
	//						$mode		... 뵭
	//										(1:Ƶ/1ʳ:ֿ)
	//						$num		... 뵭ֹ
	// Output			:	$mode1ξGlobalѿ[TopicData]˿Ƶ
	//						$mode1ʳ[ReplyData]ֿǼƤ
	//========================================================================
	function GetSingleData($db, $pdb, $board, $mode, $num) {
		global $TopicData, $ReplyData;

		$topic_table = DEF_PRE_TABLE.$board."_topic";
		$reply_table = DEF_PRE_TABLE.$board."_reply";

		if ( $mode == 1 ) {
			$SQL_query = "SELECT * FROM ".$topic_table." WHERE i_MainID = ".$num;
		} else {
			$SQL_query = "SELECT * FROM ".$reply_table." WHERE i_SubID = ".$num;
		}
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		if ( $mode == 1 ) {
			$TopicData = $row;
		} else {
			$ReplyData = $row;
		}
		$cnt = $pdb->DB_num_rows($result);
		return $cnt;
	}

	//========================================================================
	// Function Name	:	FixCheck
	//------------------------------------------------------------------------
	// Function			:	ϥɥǡ
	// Input			:	$db			...	Database Object
	//						$fname		... Ĵϥɥ̾
	//						$pass		... ѥ
	// Output			:	ǡСǼ֤
	//========================================================================
	function FixCheck($db, $pdb, $fname, $pass) {
		$com = new clsCommon();

		$SQL_query = "SELECT * FROM ".DEF_UNIQUE_TABLE." WHERE HName='".$fname."'";

		$db->Query($SQL_query, $result1);
		$cnt = $pdb->DB_num_rows($result1);
		$row1 = $pdb->DB_fetch_assoc($result1);
		if ( $cnt != 0 ) {
			$SQL_query = "SELECT * FROM ".DEF_UNIQUE_TABLE." WHERE HName='".$fname."' AND PWD='".$pass."'";
			$db->Query($SQL_query, $result2);
			$row2 = $pdb->DB_fetch_assoc($result2);
			if ( $pass != $row2['pwd'] ) { return $row1; } else { return $row2; }
		} else {
			return $row1;
		}
	}

	//========================================================================
	// Function Name	:	GetLastEntryRecord
	//------------------------------------------------------------------------
	// Function			:	ǽƥ쥳ɼ
	// Input			:	$db			...	Database Object
	//						$board		... ĴǼ̾
	// Output			:	ǽƥ쥳ֹ
	// Note				:	üƵϽ
	//========================================================================
	function GetLastEntryRecord($db, $pdb, $board) {
		$SQL_query = "SELECT i_MainID FROM ".DEF_PRE_TABLE.$board."_topic WHERE i_Flag != 2 ORDER BY i_ReplyDate DESC";
		$SQL_query .= $pdb->OffsetSQL(0, 1);
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		if ( isset($row['i_mainid']) ) { $ResultID = $row['i_mainid']; } else { $ResultID = -1; }

//		$ResultID = $row['i_mainid'];

		return $ResultID;
	}

	//========================================================================
	// Function Name	:	GetRecordCount
	//------------------------------------------------------------------------
	// Function			:	쥳ɿ
	// Input			:	$db			...	Database Object
	//						$board		... ĴǼ̾
	//						$mode		... 0:Ƶ쥳ɷ
	//										0ʳ:Ƶֹ
	// Output			:	쥳ɿ or 쥳ֹ
	// Note				:	üƵϽ
	//========================================================================
	function GetRecordCount($db, $pdb, $board, $mode) {
		if ( $mode == 0 ) {
			$SQL_query = "SELECT count(i_MainID) as Cnt FROM ".DEF_PRE_TABLE.$board."_topic";
			$SQL_query = $this->MenuMakeSQL($SQL_query);
		} else {
			$SQL_query = "SELECT MAX(i_MainID) as Cnt FROM ".DEF_PRE_TABLE.$board."_topic WHERE i_Flag != 2";
		}
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		$cnt = $row['cnt'];
		return $cnt;
	}

	//========================================================================
	// Function Name	:	IPCheck
	//------------------------------------------------------------------------
	// Function			:	IP BAN/REFERERå
	// Input			:	$db			...	Database Object
	// Output			:	== 0		... OK
	//						!= 0		... NG
	//========================================================================
	function IPCheck($db, $pdb) {
		$com = new clsCommon();

		$retval	= 0;
		$IPList	= array();
		$Ref	= array();

		$SQL_query = "SELECT AddressData, AccessKind FROM ".DEF_ACCESS_TABLE." WHERE AccessKind = 0 OR AccessKind = 1";
		$db->Query($SQL_query, $result);
		while ($row = $pdb->DB_fetch_assoc($result)) {
			if ( $row['accesskind'] == 0 ) { $IPList[] = $row['addressdata']; }
			if ( $row['accesskind'] == 1 ) { $Ref[] = $row['addressdata']; }
		}
		$remote_host = $com->GetHostName($_SERVER['REMOTE_ADDR']);
		foreach( $IPList as $val ) {
			if ( preg_match("/".$val."/", $_SERVER['REMOTE_ADDR']) ) { $retval = 1; break; }
			if ( preg_match("/".$val."/i", $remote_host) ) { $retval = 1; break; }
		}

		if ( count($Ref) != 0 ) {
			$ok = 1;
			foreach ( $Ref as $val ) {
				if ( eregi($val, $_SERVER['HTTP_REFERER']) ) { $ok = 0; break; }
			}
			if ( 1 == $ok ) { $retval = 2; }
		}

		return $retval;
	}

	//========================================================================
	// Function Name	:	BAN_ReleaseCheck
	//------------------------------------------------------------------------
	// Function			:	BAN½å
	// Input			:	$db			...	Database Object
	//						$board		... Ǽ̾
	// Output			:	== 0		... 
	//						!= 0		... ·³
	// Note				:	줿硢ξCookieϿ
	//						ʸCookieäʤ(̤ΥǡǾ񤭤ʤ
	//						¤BAN¤
	//========================================================================
	function BAN_ReleaseCheck($db, $pdb, $board) {
		global $COOKIE;

		$name		= $COOKIE['name'];
		$password	= $COOKIE['password'];
		$pwd		= $_POST['pwd'];
		$sysop_id	= $_POST['sysop_id'];
		$retval		= 0;

		if ( $sysop_id != "" ) {
			$name = $sysop_id; $password = $pwd;
		}

		if ( $name != "" && $password != "" ) {
			// HNåԤפ¤鳰
			$c_password = crypt($password, DEF_PASS_BASE);
			$FixData = $this->FixCheck($db, $pdb, $name, $c_password);
			$db->DisConnect();
			if ( $FixData ) {
				if ( $FixData['pwd'] != $c_password || $FixData['pwd'] != $password ) {
					$com				= new clsCommon();
					$COOKIE['name']		= $name; 
					$COOKIE['password']	= $password;
					$com->SetCookieData($board, "off");
				} else { $retval = 1; }
			} else { $retval = 1; }
		} else { $retval = 1; }

		return $retval;
	}

	//========================================================================
	// Function Name	:	MultipleCheck
	//------------------------------------------------------------------------
	// Function			:	ʣǡå
	// Input			:	$db			...	Database Object
	//						$board		... ĴǼ̾
	//						$targ_tbl	... Ĵơ֥̾
	//						$FieldList	...	եɵڤӥǡǼϢ
	// Output			:	== 0		... ʣʤ
	//						!= 0		... ʣͭ(ʣ)
	//========================================================================
	function MultipleCheck($db, $pdb, $board, $targ_tbl, $FieldList) {
		global $CONFIG;

		$topic_table = DEF_PRE_TABLE.$board."_topic";
		$reply_table = DEF_PRE_TABLE.$board."_reply";

		$SQL_query = "SELECT * FROM ".$targ_tbl." WHERE ";
		$buff = "";

		foreach( $FieldList as $key=>$val ) {
			if ( $val != "" ) {
				$buff .= $key."=";
				if ( preg_match("/^i_/i", $key) ) {
					$buff .= $val." AND ";
				} else {
					$val = str_replace("'","\\'",$val);
					$buff .= "'".$val."' AND ";
				}
			}
		}

		$cnt = strlen($buff);
		$buff = substr($buff, 0, $cnt-5);

		if ( $targ_tbl == $topic_table ) { $SQL_query .= $buff." ORDER BY i_TopicDate DESC";
		} else { $SQL_query .= $buff." ORDER BY i_ReplyDate DESC"; }

		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		$cnt = $pdb->DB_num_rows($result);
		if ( $cnt != 0 && $CONFIG['accept_multidata'] != 0 ) {
			if ( $targ_tbl == $topic_table ) {
				$entry_time = $row['i_topicdate'];
			} else {
				$entry_time = $row['i_replydate'];
			}
			if ( ((int)((time() - $entry_time)/3600)) >= $CONFIG['accept_multidata']) { $cnt = 0; }
		} else {
			$cnt = 0;
		}
		return $cnt;
	}

	//========================================================================
	// Function Name	:	TopicCheck
	//------------------------------------------------------------------------
	// Function			:	Ƶ
	// Input			:	$db			...	Database Object
	//						$board		... ĴǼ̾
	//						$num		... ĴƵֹ
	//						&$t_flag	... Ƶ֥ե饰(OUT)
	//										(0:̾/1:λ/2:ü/3:)
	//						&$t_mail	... ƵΥ᡼륢ɥ쥹(OUT)
	//						&$t_pwd		... ƵΥѥ(OUT)
	//						&$t_cnt		... Ƶ°ֿ(OUT)
	// Output			:	Nothing
	//========================================================================
	function TopicCheck($db, $pdb, $board, $num, &$t_flag, &$t_mail, &$t_pwd, &$t_cnt) {
		$topic_table = DEF_PRE_TABLE.$board."_topic";
		$reply_table = DEF_PRE_TABLE.$board."_reply";

		$SQL_query = "SELECT EMail, PWD, i_Flag FROM ".$topic_table." WHERE i_MainID = ".$num;
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		$t_flag = $row['i_flag'];
		$t_mail = $row['email'];
		$t_pwd = $row['pwd'];

		$SQL_query = "SELECT count(i_SubID) as Cnt FROM ".$reply_table." WHERE i_MainID = ".$num;
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		$t_cnt = $row['cnt'];
	}

	//========================================================================
	// Function Name	:	GetMaxUID
	//------------------------------------------------------------------------
	// Function			:	UIDֹ(¦)
	// Input			:	$db			...	Database Object
	//						$board		... ĴǼ̾
	// Output			:	ǡ:+1
	//						̵:DEF_UID_INIT
	//========================================================================
	function GetMaxUID($db, $pdb, $board) {
		$topic_table = DEF_PRE_TABLE.$board."_topic";
		$reply_table = DEF_PRE_TABLE.$board."_reply";

		// Topic/ReplyUIDͤ
		$SQL_query = "SELECT MAX(i_UID) as umax FROM ".$topic_table." WHERE i_Flag != 2";
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_array($result);
		$no1 = $row['umax'];

		$SQL_query = "SELECT MAX(i_UID) as umax FROM ".$reply_table;
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);
		$no2 = $row['umax'];

		// ĤӤ礭ۤͤ+1Τ֤
		if ( $no1 != "" && $no2 != "" ) {
			if ( $no1 > $no2 ) {
				$retval = $no1 + 1;
			} else if ( $no1 < $no2 ) {
				$retval = $no2 + 1;
			} else {
				$retval = $no1 + 1;
			}
		} else if ( $no1 != "" ) {
			$retval = $no1 + 1;
		} else if ( $no2 != "" ) {
			$retval = $no2 + 1;
		} else {
			$retval = DEF_UID_INIT;
		}
		return $retval;
	}

	//========================================================================
	// Function Name	:	MenuMakeSQL
	//------------------------------------------------------------------------
	// Function			:	SQLơȥ
	// Input			:	$baseSQL	...	WHERESQLơȥ
	// Output			:	줿SQLơȥʸ
	// Note				:	˥塼֤ˤäSQLѹƤ
	//========================================================================
	function MenuMakeSQL($baseSQL) {
		global $COOKIE;

		$SQL_Where1 = "";
		$SQL_Where2 = "";
		$SQL_query = $baseSQL;
		if ( $COOKIE['kindselect'] != "" && $COOKIE['kindselect'] != HEADDER_COMBO_ALLKIND && $COOKIE['kindselect'] != HEADDER_COMBO_END ) {
			$buff = $COOKIE['kindselect'];
			$SQL_Where1 = "Menu = '$buff'";
		} else {
			if ( $COOKIE['kindselect'] == HEADDER_COMBO_END ) { $SQL_Where1 = "i_Flag = 1"; }
		}
		if ( $COOKIE['finselect'] != "on" ) { $SQL_Where2 = "i_Flag != 1"; }

		$SQL_query .= " WHERE i_Flag != 2";
		if ( $SQL_Where1 != "" && $SQL_Where2 != "" ) {
			$SQL_query .= " AND $SQL_Where1 AND $SQL_Where2";
		} else if ( $SQL_Where1 == "" && $SQL_Where2 != "" ) {
			$SQL_query .= " AND $SQL_Where2";
		} else if ( $SQL_Where1 != "" && $SQL_Where2 == "" ) {
			$SQL_query .= " AND $SQL_Where1";
		}
		// 
		if ( $COOKIE['sort'] == 1 ) {
			$SQL_query .= " ORDER BY i_ReplyDate DESC";	// 쥹
		} else {
			$SQL_query .= " ORDER BY i_MainID DESC";	// ƽ
		}

		return $SQL_query;
	}

	//========================================================================
	// Function Name	:	Search
	//------------------------------------------------------------------------
	// Function			:	
	// Input			:	$board		... Ǽ̾
	//						$str		... ʸ
	// Output			:	Nothing
	//========================================================================
	function Search($db, $pdb, $board, $str) {
		global $COOKIE;
		$html	= new clsHeadFoot();
		$com	= new clsCommon();

		$buff = $str;
		$com->SetCookieData($board, "off");

		if ( get_magic_quotes_gpc()==1 ) {
			$buff = stripslashes($buff);
		}
		$buff = str_replace("\"", "&quot;", $buff);
		$buff = str_replace("'", "&#039;", $buff);

		$buff = str_replace("<", "&gt;", $buff);
		$buff = str_replace(">", "&lt;", $buff);
		$topic_table = DEF_PRE_TABLE.$board."_topic";
		$reply_table = DEF_PRE_TABLE.$board."_reply";

		$SQL_query = "SELECT ".$topic_table.".i_MainID as t_ID,".$reply_table.".i_MainID as r_ID from ".$topic_table." 
			LEFT JOIN ".$reply_table." ON ".$topic_table.".i_MainID = ".$reply_table.".i_MainID WHERE 
			".$topic_table.".i_MainID LIKE '%".$buff."%' OR ".$topic_table.".Subject LIKE '%".$buff."%' OR
			".$topic_table.".Name LIKE '%".$buff."%' OR ".$topic_table.".TagName LIKE '%".$buff."%' OR ".$topic_table.".ICQ LIKE '%".$buff."%' OR
			".$topic_table.".Comment LIKE '%".$buff."%' OR ".$topic_table.".i_UID LIKE '%".$buff."%' OR ".$topic_table.".TripID LIKE '%".$buff."%' OR
			".$reply_table.".Name LIKE '%".$buff."%' OR ".$reply_table.".TagName LIKE '%".$buff."%' OR ".$reply_table.".ICQ LIKE '%".$buff."%' OR 
			".$reply_table.".Comment LIKE '%".$buff."%' OR ".$reply_table.".i_UID LIKE '%".$buff."%' OR ".$reply_table.".TripID LIKE '%".$buff."%'
			ORDER BY ".$topic_table.".i_MainID DESC";

		$out_buff = $html->DrawHeadder("".$buff."".SEARCH_LABEL_HEADDER, 0, 0, 0, $board);
		$db->Query($SQL_query, $result);
		$before_no = -1;
		$hit = array();
		while ($row = $pdb->DB_fetch_assoc($result)) {
			$buff = $row['t_id'];
			if( $buff != "" && $before_no != $buff ) {
				$hit[] = $buff; $before_no = $buff;
			}
		}
		$out_buff .= "<br><br>";
		if ( count($hit) != 0 ) {
			require_once("./lib/drawtopic.php");
			$topic = new clsDrawTopic();
			foreach ( $hit as $num ) { 
				$out_buff .= $topic->Draw($db, $pdb, $board, 1, $num, $str);
			}
		} else {
			$out_buff .= "<B><CENTER>".SEARCH_LABEL_NOTFOUND."</B></CENTER>\n";
		}
		print $out_buff;
	}
}
?>
