<?php
class clsProxy {
	//========================================================================
	// Function Name	:	ProxyCheck
	//------------------------------------------------------------------------
	// Function			:	PROXYå
	// Input			:	Nothing
	// Output			:	== 0		... ProxyǤϤʤ
	//						!= 0		... Proxy
	//						³ʤ
	//						1:ĶѿPROXYͭʸ󤬤
	//						2:⡼ȥۥ̾PROXYͭʸ󤬤
	//						3:հ̤Ϣ³ͤʤ
	//						4:ĶѿHTTP_CONNECTIONKeep-AliveǤʤ
	//						³줿
	//							(â⡼ȥۥ̾ʤ)
	//						5:հǤʤä
	//						6:հ̤PROXYͭʸ󤬤
	//						7:հ̤Ϣ³ͤʤ
	//						³줿
	//							(⡼ȥۥ̾줿)
	//						8:հǤʤä
	//						嵭åȴ
	//						10:⡼ȥɥ쥹PROXYˤ
	//						11:IPPROXYˤ
	//========================================================================
	function ProxyCheck($db, $pdb) {
		$proxy_lv	= 0;
		$ip_info	= "";

		// Get IP & Host Info
		$remote_add		= $_SERVER['REMOTE_ADDR'];
		$remote_host	= $_SERVER['REMOTE_HOST'];
		if ( $remote_host == "" ) { $remote_host = $remote_add; }
		if ( $remote_host == $remote_add ) {
			$remote_host = @gethostbyaddr($remote_host);
		}

		// Get Browser Info
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		$user_agent = preg_replace("/(<|>|\,)/", "", $user_agent);
		if( strlen($user_agent) > 150 ) {
			$user_agent = substr( $user_agent, 0, 150 );
		}

		// Get PROXY Info
		$cache_con	= $_SERVER['HTTP_CACHE_CONTROL'];       // CACHEĹ
		$cache_info	= $_SERVER['HTTP_CACHE_INFO'];          // PROXYCACHE
		$client_ip	= $_SERVER['HTTP_CLIENT_IP'];           // ³IP
		$http_con	= $_SERVER['HTTP_CONNECTION'];          // ³
		$forwarded	= $_SERVER['HTTP_FORWARDED'];           // PROXY or Clientξ
		$proxy_con	= $_SERVER['HTTP_PROXY_CONNECTION'];    // PROXY³
		$sp_host	= $_SERVER['HTTP_SP_HOST'];             // ³IPΣ
		$via		= $_SERVER['HTTP_VIA'];                 // PROXYPROXYμࡤС
		$x_forward	= $_SERVER['HTTP_X_FORWARDED_FOR'];     // ͳIPɥ쥹
		$xonnect	= $_SERVER['HTTP_XONNECTION'];          // Ӥ
		$xroxy_con	= $_SERVER['HTTP_XROXY_CONNECTION'];    // Ӥ
		$http_from	= $_SERVER['HTTP_FROM'];                // Υɥᥤ͡
		$mod_since	= $_SERVER['HTTP_IF_MODIFIED_SINCE'];	// ƥĹ

		$pattern = "/^(\d+)\.(\d+)\.(\d+)\.(\d+)/";
		$rep = "\$1.\$2.\$3.\$4";
		if( $client_ip == preg_replace($pattern, $rep, $client_ip) )		{ $ip_info = $client_ip;
		} else if( $forwarded == preg_replace($pattern, $rep, $forwarded) )	{ $ip_info = $forwarded;
		} else if( $http_from == preg_replace($pattern, $rep, $http_from) )	{ $ip_info = $http_from;
		} else if( $sp_host == preg_replace($pattern, $rep, $sp_host) )		{ $ip_info = $sp_host;
		} else if( $via == preg_replace($pattern, $rep, $via) )				{ $ip_info = $via;
		} else if( $x_forward == preg_replace($pattern, $rep, $x_forward) )	{ $ip_info = $x_forward;
		}

		// IPǤPROXY󤬴ޤޤƤ
		if ( $ip_info == "" ) {
			if ( (preg_match("/cache|delegate|proxy|squid|via/i", $cache_con ) || preg_match("/cache|delegate|proxy|squid|via/i", $cache_info ) ||
				preg_match("/cache|delegate|proxy|squid|via/i", $proxy_con ) || preg_match("/cache|delegate|proxy|squid|via/i", $forwarded ) ||
				preg_match("/cache|delegate|proxy|squid|via/i", $xonnect ) || preg_match("/cache|delegate|proxy|squid|via/i", $via ) ||
				preg_match("/cache|delegate|proxy|squid|via/i", $xroxy_con ) || preg_match("/cache|delegate|proxy|squid|via/i", $user_agent )) &&
				( $cache_con != "" && !preg_match("/no-cache/i", $cache_con )) ){

				$proxy_lv = 1;
			}
		}

		$PList = "/^cache|cgi|cust|^dns|delegate|dummy|^fw|firewall|^gate|^gw|";
		$PList .= "^host|keeper|^ns|^news|^secure|ftp|gate|keep|mail|^magic|";
		$PList .= "proxy|prox|pop|^router|^prx|smtp|squid|^web|www|w3/i";

		// Host̾PROXYȽԤ
		$host_info = split("\.", $remote_host);
		if( $ip_info == "" && preg_match($PList, $remote_host) ) {
			$proxy_lv = 2;
		} else if( $ip_info == "" && !preg_match("/\d{2,}/", $host_info[0]) ) {
			$proxy_lv = 3;
		}
		// HTTP_CONNECTION Check
		if( $ip_info == "" && !preg_match("/Keep-Alive/i", $http_con) ) {
			$com = new clsCommon(); $agent = $com->User_Agent();
			if ( $agent['browser'] != "NetscapeNavigator" || !preg_match("/4\.7/", $agent['browser_v']) ) { $proxy_lv = 4; }
		}

		if ( $proxy_lv == 0 ) {
			// IPHostհ
			if( preg_match($pattern, $remote_host) ) {
				$ip_info = @gethostbyaddr($remote_host);
				if( preg_match($pattern, $ip_info) ) {
					// հƤIPǤʤä
					$proxy_lv = 5;
				} else {
					// հHost̾PROXYϢξäƤ뤫Ƚ
					$host_info = split("\.", $ip_info);
					if( preg_match($PList, $ip_info) ) {
						$proxy_lv = 6;
					} else if( !preg_match("/\d{2,}/", $host_info[0]) ) { $proxy_lv = 7; }
				}
			} else {
				$ip_info = gethostbyaddr($remote_add);
				if( preg_match($pattern, $ip_info) ) {
					// հƤIPǤʤä
					$proxy_lv = 8;
				} else {
//					if( preg_match($PList, $remote_host) ) { $proxy_lv = 9; }
				}
			}
		}

		if ( $proxy_lv != 0 ) {
			// PROXY˰ää硢ꥹȤ˴ޤޤƤ뤫å
			$buff = $this->ProxyRemoveCheck($db, $pdb, $remote_add, $remote_host);
			if ( $buff == 0 ) { $proxy_lv = 0; }
		} else {
			// äʤƤ⡢PROXYIP⤷HostϿƤ뤫å
			$SQL_query = "SELECT AddressData FROM ".DEF_PROXY_TABLE;
			$db->Query($SQL_query, $result);
			while ($row = $pdb->DB_fetch_row($result)) {
				if ( preg_match("/".$row[0]."/", $remote_add) ) 	{ $proxy_lv = 10; break; }
				if ( preg_match("/".$row[0]."/i", $remote_host) ) 	{ $proxy_lv = 11; break; }
			}

			// PROXY˰ää硢ꥹȤ˴ޤޤƤ뤫å
			if ( $proxy_lv != 0 ) {
				$buff = $this->ProxyRemoveCheck($db, $pdb, $remote_add, $remote_host);
				if ( $buff == 0 ) { $proxy_lv = 0; }
			}
		}

		return $proxy_lv;
	}

	//========================================================================
	// Function Name	:	ProxyRemoveCheck
	//------------------------------------------------------------------------
	// Function			:	PROXYå
	// Input			:	$db				...	Database Object
	//						$remote_add		... IPɥ쥹
	//						$remote_host	... ⡼ȥۥ̾
	// Output			:	== 0			... ꥹȤ˴ޤޤƤ
	//						== 1			... ꥹȤ˴ޤޤƤʤ
	//========================================================================
	function ProxyRemoveCheck($db, $pdb, $remote_add, $remote_host) {
		$ret_val	= 1;

		// PROXY˰ää硢ꥹȤ˴ޤޤƤ뤫å
		$SQL_query = "SELECT AddressData FROM ".DEF_ACCESS_TABLE." WHERE AccessKind = 2 ";
		$db->Query($SQL_query, $result);
		while ($row = $pdb->DB_fetch_row($result)) {
			if ( preg_match("/".$row[0]."/", $remote_add) )		{ $ret_val = 0; break; }
			if ( preg_match("/".$row[0]."/i", $remote_host) )	{ $ret_val = 0; break; }
		}
		return $ret_val;
	}

}
?>
