<?php
class clsMySQL {
	var $HostNM;
	var $UserNM;
	var $Pass;
	var $DBName;
	var $ConnectionID;
	var $ErrMsg;
	//========================================================================
	// Function Name	:	clsMySQL
	//------------------------------------------------------------------------
	// Function			:	󥹥ȥ饯
	// Input			:	$host_name	... ۥ̾
	//						$user		... ³桼̾
	//						$pass		... 嵭ѥ
	//						$dbname		... ³ǡ١̾
	//						$errdisp	... 顼ɽե饰(Def:true)
	// Output			:	Nothing
	// Note				:	Privateѿ˥ǡ
	//========================================================================
	function clsMySQL($host_nm, $user, $pass, $dbname, $errdisp=true) {
		$this->HostNM	= $host_nm;
		$this->UserNM	= $user;
		$this->Pass		= $pass;
		$this->DBName	= $dbname;
		$this->ErrMsg	= "";
		$RetVal = $this->Connect();
		if (!$RetVal && $errdisp ) {
			print $this->ErrMsg;
			exit;
		}
	}

	//========================================================================
	// Function Name	:	Connect
	//------------------------------------------------------------------------
	// Function			:	ǡݥ١³
	// Input			:	Nothing
	// Output			:	True		... ³λ
	//						False		... ³
	//========================================================================
	function Connect() {
		$this->ConnectionID = @mysql_connect($this->HostNM, $this->UserNM, $this->Pass);
		if (!$this->ConnectionID) {
			$this->ErrMsg = "<p>Can not connect Database</p>";
			return false;
		}
		$Stat = @mysql_select_db($this->DBName);
		if (!$Stat) {
			$this->ErrMsg = "<p>Database is nothing</p>";
			return false;
		}
		$SQLString = "set names '".DEF_DB_CODE."'";
		$Result = @mysql_query($SQLString);
		return true;
	}

	//========================================================================
	// Function Name	:	DisConnect
	//------------------------------------------------------------------------
	// Function			:	ǡݥ١
	// Input			:	Nothing
	// Output			:	Nothing
	//========================================================================
	function DisConnect() {
		@mysql_close($this->ConnectionID);
	}

	//========================================================================
	// Function Name	:	Query
	//------------------------------------------------------------------------
	// Function			:	SQLȯ
	// Input			:	$SQLString	... ȯԤSQLơȥ
	//						&$Result	... ̳Ǽ(OUT)
	// Output			:	Nothing
	//========================================================================
	function Query($SQLString, &$Result) {
		$com = new clsCommon();
		$buff = $SQLString;
		// DBʸɤ㤦ꤷѴԤ(DEF_CODE_MODIFY˽)
		$SQLString = $com->ModifyCode($SQLString, True, DEF_CODE_MODIFY);
		$Result = @mysql_query($SQLString);
		if(mysql_error()) {
			$com->ErrorDisp("<p>Query Error</p>");
			exit;
		}
	}

	//========================================================================
	// Function Name	:	Insert_Data
	//------------------------------------------------------------------------
	// Function			:	ɲSQLơȥȯ
	// Input			:	$targ_tbl	... ɲäơ֥̾
	//						$FieldList	... ɲåǡǼϢ
	// Output			:	Nothing
	// Note				:	ϢΥե̾Ȥ
	//						SQLơȥȤȯԤ
	//========================================================================
	function Insert_Data($targ_tbl, $FieldList, $Quotes=True) {
		$dat = array();
		// ơȥȡFieldޤǺ
		$SQL_Str = "INSERT INTO ".$targ_tbl." ";
		$buff = "";
		foreach( $FieldList as $key=>$val ) {
			$trimchk = trim($val);
			if ( $val != "" ) {
				$buff .= $key.",";
				if ( preg_match("/^i_/i", $key) ) {
					$dat[] = $val."<>i";
				} else {
					$dat[] = $val."<>c";
				}
			}
		}
		$cnt = strlen($buff);
		$buff = substr($buff, 0, $cnt-1);
		$SQL_Str .= "(".$buff.") VALUES (";

		// ºݤǡ
		$buff = "";
		foreach( $dat as $val ) {
			$Entry = split("<>", $val);
			if ( $Entry[1] == "i" ) {
				$buff .= $Entry[0].",";
			} else {
				if ( $Quotes ) {
					if ( get_magic_quotes_gpc()==0 ) {
						$Entry[0] = addslashes($Entry[0]);
					}
				}
				$buff .= "'".$Entry[0]."',";
			}
		}
		$cnt = strlen($buff);
		$buff = substr($buff, 0,  $cnt-1);
		$SQL_Str = $SQL_Str.$buff.")";

		$this->Query($SQL_Str, $result);
	}

	//========================================================================
	// Function Name	:	Update_Data
	//------------------------------------------------------------------------
	// Function			:	SQLơȥȯ
	// Input			:	$targ_tbl	... ơ֥̾
	//						$Where		... 
	//										(Whereʹߤ򤽤Τޤ޵)
	//						$FieldList	... ǡǼϢ
	// Output			:	Nothing
	// Note				:	ϢΥե̾Ȥ
	//						SQLơȥȤȯԤ
	//========================================================================
	function Update_Data($targ_tbl, $Where, $FieldList, $Quotes=True) {
		$dat = array();
		$SQL_Str = "UPDATE ".$targ_tbl." SET ";
		$buff = "";
		foreach( $FieldList as $key=>$val ) {
			if ( $val != "" ) {
				$buff .= $key."=";
				if ( preg_match("/^i_/i", $key) ) {
					$buff .= $val.",";
				} else {
					if ( $Quotes ) {
						if ( get_magic_quotes_gpc()==0 ) {
							$val = addslashes($val);
						}
					}
					$buff .= "'".$val."',";
				}
			} else {
				$buff .= $key."=NULL,";
			}
		}
		$cnt = strlen($buff);
		$buff = substr($buff, 0, $cnt-1);
		$SQL_Str .= $buff." WHERE ".$Where;

		$this->Query($SQL_Str, $result);

	}

}
?>
